<template>
  <div class="row mt-3">
    <div class="col-12">
      <bus-lines-nav
        :bus-line-list="busLineList"
        v-model:selected-bus-line="selectedBusLine"
        :loading="loading"
        :error="error"
      />
    </div>
  </div>
  <div class="row mt-3">
    <div class="col-6">
      <bus-lines-stops
        :bus-line="selectedBusLine"
        :bus-line-stops="selectedStopList"
        v-model:selected-bus-stop="selectedBusStop"
      />
    </div>
    <div class="col-6">
      <bus-lines-stop-schedule
        :schedule="selectedSchedule"
        :bus-stop="selectedBusStop"
      />
    </div>
  </div>
</template>

<script setup lang="ts">
import { ref, computed, watch } from 'vue';
import BusLinesNav from '@/features/bus-lines/bus-lines-nav/BusLinesNav.vue';
import BusLinesStops from '@/features/bus-lines/bus-lines-stops/BusLinesStops.vue';
import BusLinesStopSchedule from '@/features/bus-lines/bus-lines-stop-schedule/BusLinesStopSchedule.vue';
import { useStore } from '@/store';

const store = useStore();

const linesList = computed(() => {
  return store.getters.linesList;
});

const loading = computed(() => {
  return store.state.loading;
});

const error = computed(() => {
  return store.state.error;
});

const selectedBusLine = ref<number | undefined>(undefined);
const busLineList = computed(() => {
  return Object.keys(linesList.value).map(Number);
});

const selectedStopList = computed(() => {
  if (typeof selectedBusLine.value === 'number') {
    return Object.values(linesList.value[selectedBusLine.value]);
  }
  return [];
});

const selectedBusStop = ref(undefined);

const selectedSchedule = computed(() => {
  if (!selectedBusLine.value || !selectedBusStop.value) {
    return [];
  }
  return linesList.value[selectedBusLine.value][
    selectedBusStop.value
  ].stops.map((item) => item.time);
});

watch(
  () => selectedBusLine.value,
  () => {
    selectedBusStop.value = undefined;
  }
);
</script>
